#include "interface.h"
#include "parallel.h"
#include <stdio.h>

void check_(complex *BRAU, complex *BRAL, complex *STAIRS, short *FENO,
            int *FELI, int *NELI, short *IBUSO, short *PNODIA, int *NBUS)
{
   FILE *OutputFile;
   char OutputFilename[80];
   int i;

   int M;
   int NODEA;
   int NORDA;
   int NODEB;
   int NORDB;

   int JB;
   int NZero;
   static File_num = 0;

   int Symmetric = TRUE;

   parallel_cube_host_(BRAU, BRAL, STAIRS, FENO, FELI, NELI, IBUSO, PNODIA,
                       NBUS);

   sprintf(OutputFilename, "%s%d.dat", "Edge", File_num);

   if ((OutputFile = fopen(OutputFilename, "w")) == NULL)
   {
      perror("check_");
      exit(1);
   }

   for (i = 0; i < *NBUS - 1; i++)
   {
      NODEA = (int) IBUSO[i] - 1;
#ifdef DEBUG_check
      printf("NODEA = %d\n", NODEA);
#endif
      printf("A[%d][%d] = (%g, %g)\n", NODEA, NODEA, STAIRS[NODEA].real,
             STAIRS[NODEA].imag);

      M = FELI[NODEA] - 1;
      NODEB = FENO[M] - 1;

#ifdef DEBUG_check
      printf("NODEB = %d\n", NODEB);
#endif

      NZero = 0;
      while (NODEB >= 0)
      {
         NORDA = PNODIA[NODEA] - 1;

#ifdef DEBUG_check
         printf("NORDA = %d\n", NORDA);
#endif

         NORDB = PNODIA[NODEB] - 1;

#ifdef DEBUG_check
         printf("NORDB = %d\n", NORDB);
#endif
         if (NORDB > NORDA)
         {
            NZero++;
            JB = (M >> 1);

            if (NODEA < NODEB)
            {
               printf("A[%d][%d] = (%g, %g)\n", NODEA, NODEB, BRAU[JB].real,
                      BRAU[JB].imag);
               printf("A[%d][%d] = (%g, %g)\n", NODEB, NODEA, BRAL[JB].real,
                      BRAL[JB].imag);

               fprintf(OutputFile, "%d %d\n", NODEB, NODEA);
            }
            else
            {
               printf("A[%d][%d] = (%g, %g)\n", NODEA, NODEB, BRAL[JB].real,
                      BRAL[JB].imag);
               printf("A[%d][%d] = (%g, %g)\n", NODEB, NODEA, BRAU[JB].real,
                      BRAU[JB].imag);
               fprintf(OutputFile, "%d %d\n", NODEA, NODEB);
            }
            if (!((BRAL[JB].real == BRAU[JB].real)
                  && (BRAL[JB].imag == BRAU[JB].imag)))
            {
               printf("Tag not summetric values\n");
               Symmetric = FALSE;
            }
         }
         M = NELI[M] - 1;
         NODEB = FENO[M] - 1;
      }
   }

   NODEA = (int) IBUSO[*NBUS - 1] - 1;
   printf("A[%d][%d] = (%g, %g)\n", NODEA, NODEA, STAIRS[NODEA].real,
          STAIRS[NODEA].imag);

   fprintf(OutputFile, "matrix is %s\n", (Symmetric == TRUE) ? "Symmetric" :
           "Not Symmetric");

   fclose(OutputFile);
   File_num++;
}

